/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "button.h"

#include <qpainter.h>

#include <kdebug.h>
#include <kiconeffect.h>
#include <kconfig.h>

Button::Button(KConfig *cfg, const QString &path, const QString &name)
    : PixmapButton(), ThemeObject(cfg, path, name)
{
    QPixmap pixmap(path + "/" + cfg->readEntry("Pixmap", QString::null));
    setNormalPixmap(pixmap);
    
    pixmap = QPixmap(path + "/" + cfg->readEntry("HoverPixmap", QString::null));
    setHoverPixmap(pixmap);
    
    QString action = cfg->readEntry("Action", QString::null);
    if (action == "Lock")
        m_action = Theme::LockAction;
    else if (action == "Logout")
        m_action = Theme::LogoutAction;
    else
        m_action = Theme::NoAction;
    
    m_actionAuthorized = Theme::actionAuthorized(m_action);
    
}


Button::~Button()
{
}

void Button::slotClicked()
{
    if (m_action != Theme::NoAction && m_actionAuthorized)
        execAction(m_action);
}

bool Button::authorized()
{
    return m_actionAuthorized;
}

void Button::draw(QPainter *p, QRect rect)
{
    drawButton(p);
}
#include "button.moc"
