/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FIRSTLEVELMENU_H
#define FIRSTLEVELMENU_H

#include <qpixmap.h>
#include "themeobject.h"
#include "pixmaplistview.h"
#include "menumanager.h"

class KConfig;
class KServiceGroup;
class FirstLevelMenu;


class FirstLevelMenuItem : public PixmapListViewItem
{
public:
    FirstLevelMenuItem(FirstLevelMenu *menu, Menu::Group *group);
    FirstLevelMenuItem(FirstLevelMenu *menu, QListViewItem *after);
            
    QString relPath() { return m_relPath; }
    
protected:
    virtual void drawContents(QPainter *p, const QColorGroup &cg, int width, int height);
    
private:
    QString m_relPath;
};

/**
	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class FirstLevelMenu : public PixmapListView, public ThemeObject
{
Q_OBJECT
public:
    FirstLevelMenu(KConfig *cfg, const QString &path, const QString &name);
    ~FirstLevelMenu();
    
    /**
     * Reimplemented from parent
     * @see ThemeObject::objectType()
     */
    Theme::ObjectType objectType() { return Theme::FirstLevelMenuObj; }
    
    void listServices(const Menu::MenuList& menu);
    
    virtual void draw(QPainter *p, QRect rect);
    
public slots:
    void slotClicked(QListViewItem *item);
    void slotSearching(bool s);
       
signals:
    void serviceGroupSelected(const QString &relPath);

};

#endif
