/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MENUAPPLET_H
#define MENUAPPLET_H

#include <kpanelapplet.h>
#include <menumanager.h>
class PixmapButton;
class KPopupMenu;

/**
	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class MenuApplet : public KPanelApplet
{
Q_OBJECT
public:
    MenuApplet(const QString &configFile, Type t=KPanelApplet::Normal, int actions=0, QWidget *parent=0, 
               const char *name=0, WFlags f=0);
    ~MenuApplet();
    
    virtual int widthForHeight(int height) const;
    virtual int heightForWidth(int width) const;
private:
    PixmapButton *m_button;
    KPopupMenu *m_menu;
    
private slots:
    void slotToggle(bool on);
    void slotClicked();
};

#endif
