/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MENUWIDGET_H
#define MENUWIDGET_H

#include <qwidget.h>
#include <qstring.h>
#include <qdict.h>
#include <qbitmap.h>

#include "button.h"
#include "themeobject.h"

namespace Menu
{
    class Manager;
}

/**
	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class MenuWidget : public QWidget
{
Q_OBJECT
public:
    MenuWidget(QWidget *parent = 0, const char *name = 0);

    ~MenuWidget();
    
    void addObject(ThemeObject *object);
    
    void applyTheme(const QString &theme = QString::null);
    void applyKbfxTheme(const QString &theme);
    
    QBitmap mask() const { return m_mask; }
    
private:
    QDict<ThemeObject> m_objectList;
    Menu::Manager *m_menuManager;
    QBitmap m_mask;
    
private:
    void prepareObjects();
};

#endif
