/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PIXMAPBUTTON_H
#define PIXMAPBUTTON_H

#include <qbutton.h>
#include <qpixmap.h>

/**
	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class PixmapButton : public QButton
{
Q_OBJECT
public:
    PixmapButton(QWidget *parent = 0, const char *name = 0);

    ~PixmapButton();
    
    void setHoverPixmap(const QPixmap &pixmap);
    void setNormalPixmap(const QPixmap &pixmap);
    void setDownPixmap(const QPixmap &pixmap);
    
    void setToggleBtn(bool t);
    
protected:
    /**
 * Reimplemented from parent
 * @see QButton::drawButton()
     */
    void drawButton(QPainter *p);
    void drawButtonLabel(QPainter *p);

    void enterEvent(QEvent *e);
    void leaveEvent(QEvent *e);
    
    /**
     * Check if the action this button represents can be executed
     */
    virtual bool authorized();
    
protected:
    virtual void resizeEvent(QResizeEvent *e);
            
private:
    QPixmap m_hoverPixmap;
    QPixmap m_pixmap;
    QPixmap m_downPixmap;
    bool m_hover;

protected slots:
    virtual void slotClicked();
    
};

#endif
