/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko                          *
 *   boiko@mandriva.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "pixmapwidget.h"

#include <qpainter.h>
#include <qbitmap.h>
#include <kdebug.h>
PixmapWidget::PixmapWidget(QWidget *parent, const char *name)
: QWidget(parent, name, Qt::WNoAutoErase)
{
}


PixmapWidget::~PixmapWidget()
{
}

void PixmapWidget::paintEvent(QPaintEvent *e)
{
    QPainter p(this);
    
    paint(&p, e->rect());
    
    // draw only the necessary
    //QMemArray<QRect> rects = e->region().rects();
    //for (unsigned int i=0; i < rects.size(); ++i)
    //    bitBlt(this, rects[i].topLeft(), &bg, rects[i], Qt::CopyROP, false);
}

void PixmapWidget::setPixmap(const QPixmap &pixmap)
{
    m_pixmap = pixmap;
    
    if (!m_pixmap.isNull())
    {
        setMinimumSize(m_pixmap.size());
        resize(m_pixmap.size());
    }
    repaint();
}

void PixmapWidget::paint(QPainter *p, QRect r)
{
    /* CHECK: I don't know what is faster, if bitblitting, or painting
    this needs some test*/
    QPixmap bg;
    if (backgroundPixmap())
        bg = *backgroundPixmap();
    else
        bg = QPixmap(size());
    
    if (!m_pixmap.isNull())
    {
        QPainter painter(&bg);
        //p.eraseRect(rect());
        painter.drawPixmap(QPoint(0,0), m_pixmap);
        //if (m_pixmap.hasAlpha())
        //    setMask(*m_pixmap.mask());
    }
    
    kdDebug() << "Painting rect " << r << endl;
    p->drawPixmap(r.topLeft(), bg, r);
}
#include "pixmapwidget.moc"
