/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "searchbar.h"
#include "pixmapwidget.h"
#include <qlineedit.h>
#include <qlayout.h>

#include <kconfig.h>
#include <kdebug.h>
#include <qpixmap.h>
SearchBar::SearchBar(KConfig *cfg, const QString &path, const QString &name)
 : QLineEdit(0), ThemeObject(cfg, path, name)
{
    QString pix = cfg->readEntry("Background",QString::null);
    m_background = QImage(path + "/" + pix);
    setBackgroundPixmap(QPixmap(m_background.scale(size())));
    setFrameStyle(QFrame::Plain | QFrame::NoFrame);
    
    resize(cfg->readSizeEntry("Size", &sizeHint()));
    
    connect(this, SIGNAL(textChanged(const QString&)),
            this, SLOT(slotTextChanged(const QString&)));
}


SearchBar::~SearchBar()
{
}

void SearchBar::slotTextChanged(const QString &text)
{
    emit search(text);
}

void SearchBar::slotClear()
{
    clear();
}

void SearchBar::resizeEvent(QResizeEvent *e)
{
    setBackgroundPixmap(QPixmap(m_background.scale(e->size())));
}

void SearchBar::draw(QPainter *p, QRect rect)
{
    drawContents(p);
}

#include "searchbar.moc"
