/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SEARCHBAR_H
#define SEARCHBAR_H

#include <qlineedit.h>
#include <qimage.h>
#include "themeobject.h"

class PixmapWidget;
class QLineEdit;
/**
	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class SearchBar : public QLineEdit, public ThemeObject
{
Q_OBJECT
public:
    SearchBar(KConfig *cfg, const QString &path, const QString &name);

    ~SearchBar();
    
    /**
     * Reimplemented from parent
     * @see ThemeObject::objectType()
     */
    Theme::ObjectType objectType() { return Theme::SearchBarObj; }
    
    virtual void draw(QPainter *p, QRect rect);
    
protected:
    virtual void resizeEvent(QResizeEvent *e);
    
private:
    QImage m_background;
    
signals:
    void search(const QString &text);
    
public slots:
    void slotClear();
    
private slots:
    void slotTextChanged(const QString &text);
};

#endif
