/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SECONDLEVELMENU_H
#define SECONDLEVELMENU_H

#include "pixmaplistview.h"
#include "themeobject.h"
#include "menumanager.h"

class KConfig;
class KService;
class SecondLevelMenu;

using namespace Menu;
class SecondLevelMenuItem : public PixmapListViewItem
{
public:
    SecondLevelMenuItem(SecondLevelMenu *menu, Menu::Entry *entry);
    SecondLevelMenuItem(SecondLevelMenu *menu, QListViewItem *after);
    
    QString name();
    QString comment();
    QString genericName();
    QString exec();
    QString path();
    QPixmap icon() const;
    
protected:
    void drawContents(QPainter *p, const QColorGroup &cg, int width, int height);
    
private:
    Menu::Entry *m_entry;
    
};

class SecondLevelMenu : public PixmapListView, public ThemeObject
{
Q_OBJECT
public:
    SecondLevelMenu(KConfig *cfg, const QString &path, const QString &name);
    ~SecondLevelMenu();
    
    /**
     * Reimplemented from parent
     * @see ThemeObject::objectType()
     */
    Theme::ObjectType objectType() { return Theme::SecondLevelMenuObj; }
    
    virtual void draw(QPainter *p, QRect rect);
    
protected:
    virtual QDragObject *dragObject();
    
public slots:
    void listMenuEntries(const EntryList& list);
    void slotClicked(QListViewItem *item);
};

#endif
