/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "text.h"

#include <kdebug.h>
#include <kuser.h>
#include <kconfig.h>
Text::Text(KConfig *cfg, const QString &path, const QString &name)
 : TextWidget(), ThemeObject(cfg, path, name)
{
    
    QFont f( "Times", 12, QFont::Bold );
    
    setFont(f);
    
    QString txt = cfg->readEntry("Text", QString::null);
    
    if (txt == "%username")
    {
        KUser user;
        txt = user.loginName();
    }
    else if (txt.isNull())
        txt = "Unknown text";
        
    QString style = cfg->readEntry("Case", "DontChange");
    
    if (style == "Upper")
        txt = txt.upper();
    else if (style == "Lower")
        txt = txt.lower();
    
    setText(txt);
    show();
}


Text::~Text()
{
}

void Text::draw(QPainter *p, QRect rect)
{
    drawContents(p);
}


#include "text.moc"
