/***************************************************************************
 *   Copyright (C) 2006 by Gustavo Pichorim Boiko   *
 *   boiko@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THEMEOBJECT_H
#define THEMEOBJECT_H

#include "theme.h"
#include <qpoint.h>

/**
Every theme object should inherit this class

	@author Gustavo Pichorim Boiko <boiko@mandriva.com>
*/
class ThemeObject
{
public:
    ThemeObject(KConfig *cfg, const QString &path, const QString &name);

    virtual ~ThemeObject();
    
    /**
     * Returns the object type. This should be reimplemented in children
     */
    virtual Theme::ObjectType objectType() = 0;
    QString objectName() { return m_name; }
    
    void setPosition(QPoint position) { m_position = position; }
    QPoint position() { return m_position; }
    
    virtual void draw(QPainter *p, QRect rect);
    
private:
    QPoint m_position;
    QString m_name;
};

#endif
